<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPieceEvent ArrayType
 * @subpackage Arrays
 */
class ArrayOfPieceEvent extends AbstractStructArrayBase
{
    /**
     * The ArrayOfPieceEventItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PieceEvent[]
     */
    public $ArrayOfPieceEventItem;
    /**
     * Constructor method for ArrayOfPieceEvent
     * @uses ArrayOfPieceEvent::setArrayOfPieceEventItem()
     * @param \StructType\PieceEvent[] $arrayOfPieceEventItem
     */
    public function __construct(array $arrayOfPieceEventItem = array())
    {
        $this
            ->setArrayOfPieceEventItem($arrayOfPieceEventItem);
    }
    /**
     * Get ArrayOfPieceEventItem value
     * @return \StructType\PieceEvent[]|null
     */
    public function getArrayOfPieceEventItem()
    {
        return $this->ArrayOfPieceEventItem;
    }
    /**
     * Set ArrayOfPieceEventItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceEvent[] $arrayOfPieceEventItem
     * @return \ArrayType\ArrayOfPieceEvent
     */
    public function setArrayOfPieceEventItem(array $arrayOfPieceEventItem = array())
    {
        foreach ($arrayOfPieceEventItem as $arrayOfPieceEventArrayOfPieceEventItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfPieceEventArrayOfPieceEventItemItem instanceof \StructType\PieceEvent) {
                throw new \InvalidArgumentException(sprintf('The ArrayOfPieceEventItem property can only contain items of \StructType\PieceEvent, "%s" given', is_object($arrayOfPieceEventArrayOfPieceEventItemItem) ? get_class($arrayOfPieceEventArrayOfPieceEventItemItem) : gettype($arrayOfPieceEventArrayOfPieceEventItemItem)), __LINE__);
            }
        }
        $this->ArrayOfPieceEventItem = $arrayOfPieceEventItem;
        return $this;
    }
    /**
     * Add item to ArrayOfPieceEventItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceEvent $item
     * @return \ArrayType\ArrayOfPieceEvent
     */
    public function addToArrayOfPieceEventItem(\StructType\PieceEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PieceEvent) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfPieceEventItem property can only contain items of \StructType\PieceEvent, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArrayOfPieceEventItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PieceEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PieceEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PieceEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PieceEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PieceEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfPieceEventItem
     */
    public function getAttributeName()
    {
        return 'ArrayOfPieceEventItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPieceEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
