<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfShipmentEvent ArrayType
 * @subpackage Arrays
 */
class ArrayOfShipmentEvent extends AbstractStructArrayBase
{
    /**
     * The ArrayOfShipmentEventItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ShipmentEvent[]
     */
    public $ArrayOfShipmentEventItem;
    /**
     * Constructor method for ArrayOfShipmentEvent
     * @uses ArrayOfShipmentEvent::setArrayOfShipmentEventItem()
     * @param \StructType\ShipmentEvent[] $arrayOfShipmentEventItem
     */
    public function __construct(array $arrayOfShipmentEventItem = array())
    {
        $this
            ->setArrayOfShipmentEventItem($arrayOfShipmentEventItem);
    }
    /**
     * Get ArrayOfShipmentEventItem value
     * @return \StructType\ShipmentEvent[]|null
     */
    public function getArrayOfShipmentEventItem()
    {
        return $this->ArrayOfShipmentEventItem;
    }
    /**
     * Set ArrayOfShipmentEventItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ShipmentEvent[] $arrayOfShipmentEventItem
     * @return \ArrayType\ArrayOfShipmentEvent
     */
    public function setArrayOfShipmentEventItem(array $arrayOfShipmentEventItem = array())
    {
        foreach ($arrayOfShipmentEventItem as $arrayOfShipmentEventArrayOfShipmentEventItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfShipmentEventArrayOfShipmentEventItemItem instanceof \StructType\ShipmentEvent) {
                throw new \InvalidArgumentException(sprintf('The ArrayOfShipmentEventItem property can only contain items of \StructType\ShipmentEvent, "%s" given', is_object($arrayOfShipmentEventArrayOfShipmentEventItemItem) ? get_class($arrayOfShipmentEventArrayOfShipmentEventItemItem) : gettype($arrayOfShipmentEventArrayOfShipmentEventItemItem)), __LINE__);
            }
        }
        $this->ArrayOfShipmentEventItem = $arrayOfShipmentEventItem;
        return $this;
    }
    /**
     * Add item to ArrayOfShipmentEventItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ShipmentEvent $item
     * @return \ArrayType\ArrayOfShipmentEvent
     */
    public function addToArrayOfShipmentEventItem(\StructType\ShipmentEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ShipmentEvent) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfShipmentEventItem property can only contain items of \StructType\ShipmentEvent, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArrayOfShipmentEventItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ShipmentEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ShipmentEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ShipmentEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ShipmentEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ShipmentEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfShipmentEventItem
     */
    public function getAttributeName()
    {
        return 'ArrayOfShipmentEventItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfShipmentEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
