<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Response StructType
 * @subpackage Structs
 */
class Response extends AbstractStructBase
{
    /**
     * The ServiceHeader
     * @var \StructType\ServiceHeader
     */
    public $ServiceHeader;
    /**
     * Constructor method for Response
     * @uses Response::setServiceHeader()
     * @param \StructType\ServiceHeader $serviceHeader
     */
    public function __construct(\StructType\ServiceHeader $serviceHeader = null)
    {
        $this
            ->setServiceHeader($serviceHeader);
    }
    /**
     * Get ServiceHeader value
     * @return \StructType\ServiceHeader|null
     */
    public function getServiceHeader()
    {
        return $this->ServiceHeader;
    }
    /**
     * Set ServiceHeader value
     * @param \StructType\ServiceHeader $serviceHeader
     * @return \StructType\Response
     */
    public function setServiceHeader(\StructType\ServiceHeader $serviceHeader = null)
    {
        $this->ServiceHeader = $serviceHeader;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Response
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
